/********************************************************
 * File: smproto.h (Listing 6)
 * Title: Function prototypes
 * Author: Allen Holub
 ********************************************************/

static  int get(FILE *fp);
static  void push(int c);
static  void pushb(int n,char *buf);
static  int cmp(char *substr,char *str);
extern  int gtok(FILE *input);

extern  void error(char *fmt,...);
static  char *tok_to_str(enum token tok);
static  int expected(enum token first,...);
extern  int checkstate(int state);
extern  int checkcol(int state);
extern  void description(void );
extern  int state(void );
extern  int body(void );
extern  int transition(void );
extern  int on_val(int nextstate);
extern  int value(void );
extern  int literal(void );
extern  char *ccl( char *cclbuf );
extern  void addstate(int, int, int);
extern  int char_or_num(void);
extern  void print_tables(void);
extern  int main(void );

extern  void print_array(FILE *, int *, int, int);
